<?php
/*****************************************************************************
* www.softiran.org
*****************************************************************************/

/**
 * @connect_module_class_name Cmabna
 *
 */

class Cmabna extends PaymentModule{

	function _initVars(){
		
		$this->title 		= Cmabna_TTL;
		$this->description 	= Cmabna_DSCR;
		$this->sort_order 	= 1;
		$this->Settings = array( 
			"CONF_PAYMENTMODULE_MABNA_MERCHANT_ACCOUNT",
			"CONF_PAYMENTMODULE_MABNA_TERMINAL",
			"CONF_PAYMENTMODULE_MABNA_RIAL_CURRENCY"
			);
	}

	function after_processing_html( $orderID ) 
	{
		$order = ordGetOrder( $orderID );
		if ( $this->_getSettingValue('CONF_PAYMENTMODULE_MABNA_RIAL_CURRENCY') > 0 )
		{
			$PAcurr = currGetCurrencyByID ( $this->_getSettingValue('CONF_PAYMENTMODULE_MABNA_RIAL_CURRENCY') );
			$PAcurr_rate = $PAcurr["currency_value"];
		}
		if (!isset($PAcurr) || !$PAcurr)
		{
			$PAcurr_rate = 1;
		}else		
		{			
			$PAcurr_rate = 10;		
		}
		$order_amount = round($order["order_amount"]);
		$modID =  $this ->get_id();
        $amount = $order_amount*$PAcurr_rate; 
		$redirectAddress = (CONF_FULL_SHOP_URL."?mabna&modID=$modID&pay=1&orderID=$orderID");
		
		$merchant = $this->_getSettingValue('CONF_PAYMENTMODULE_MABNA_MERCHANT_ACCOUNT');
		$terminal = $this->_getSettingValue('CONF_PAYMENTMODULE_MABNA_TERMINAL');
		
		
		$invoiceNumber = time();
		$source = $amount . $invoiceNumber . $merchant . $redirectAddress . $terminal;
		$pat = dirname(__FILE__);
		$fp = fopen($pat . '/../../../public.txt', "r");
		$pub_key = fread($fp, 8192);
		fclose($fp);
		if (strpos($pub_key, '-----BEGIN PUBLIC KEY-----') === false)
			$pub_key = "-----BEGIN PUBLIC KEY-----\n" . $pub_key;

		if (strpos($pub_key, '-----END PUBLIC KEY-----') === false)
			$pub_key .= "\n-----END PUBLIC KEY-----";


		// Amount
		$key_resource = openssl_get_publickey($pub_key);

		openssl_public_encrypt($amount, $crypttext, $key_resource);

		$Amount = base64_encode($crypttext);
		// CRN

		openssl_public_encrypt($invoiceNumber, $crypttext, $key_resource);
		$CRN = base64_encode($crypttext);

		// MID
		openssl_public_encrypt($merchant, $crypttext, $key_resource);
		$MID = base64_encode($crypttext);

		// TID
		openssl_public_encrypt($terminal, $crypttext, $key_resource);
		$TID = base64_encode($crypttext);

		// redirectAddress
		openssl_public_encrypt($redirectAddress, $crypttext, $key_resource);
		$referal = base64_encode($crypttext);

		$key = file_get_contents($pat . '/../../../private.txt');

		if (strpos($key, '-----BEGIN PRIVATE KEY-----') === false)
			$key = "-----BEGIN PRIVATE KEY-----\n" . $key;

		if (strpos($key, '-----END PRIVATE KEY-----') === false)
			$key .= "\n-----END PRIVATE KEY-----";

		$priv_key = openssl_pkey_get_private($key);
		$signature = '';
		openssl_sign($source, $signature, $priv_key, OPENSSL_ALGO_SHA1);
		$inputArray = array("Token_param" => array("AMOUNT" => $Amount,
			"CRN" => $CRN,
			"MID" => $MID,
			"REFERALADRESS" => $referal,
			"SIGNATURE" => base64_encode($signature),
			"TID" => $TID,
		));
		
		if(!function_exists('timestamp_to_iso8601'))
		{
			include_once('nusoap.php');
		}
		
		$__SOAP = "https://mabna.shaparak.ir/TokenService?wsdl";
		$client = new nusoap_client($__SOAP, 'wsdl');
		$WSResult = $client->call("reservation", $inputArray);
		
		$signature = base64_decode($WSResult['return']['signature']);
		$ok = openssl_verify($WSResult['return']['token'], $signature, $key_resource);
		openssl_free_key($key_resource);
		
		if ($ok ==1 && $WSResult['return']['result'] == 0) 
		{
			$data['TOKEN'] = $WSResult['return']['token'];
			$this->redirect_post('https://mabna.shaparak.ir',$data);
			exit ;
		}else
		{
			echo '<p>خطا در ساخت توکن : </p>'.$WSResult['return']['token'];
		}
		
		return;
	}
	function redirect_post($url, array $data)
	{

	  echo '<html xmlns="http://www.w3.org/1999/xhtml">
		<head>
		<title>در حال اتصال ...</title>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
		<style type="text/css">
		#main {
			background-color: #F1F1F1;
			border: 1px solid #CACACA;
			height: 90px;
			left: 50%;
			margin-left: -265px;
			position: absolute;
			top: 200px;
			width: 530px;
		}
		#main p {
			color: #757575;
			direction: rtl;
			font-family: Arial;
			font-size: 16px;
			font-weight: bold;
			line-height: 27px;
			margin-top: 30px;
			padding-right: 60px;
			text-align: right;
		}
		</style>
			<script type="text/javascript">
				function closethisasap() {
					document.forms["redirectpost"].submit();
				}
			</script>
		</head>
		<body onload="closethisasap();">';
	   echo '<form name="redirectpost" method="post" action="'.$url.'">';
		   
			if ( !is_null($data) ) {
				foreach ($data as $k => $v) {
					echo '<input type="hidden" name="' . $k . '" value="' . $v . '"> ';
				}
			}
		   
	   echo' </form><div id="main">
	<p>درحال اتصال به درگاه بانک</p></div>
		</body>
		</html>';
	   
		exit;

	}
	
	function _initSettingFields(){
		
		$this->SettingsFields['CONF_PAYMENTMODULE_MABNA_MERCHANT_ACCOUNT'] = array(
			'settings_value' 		=> '', 
			'settings_title' 			=> Cmabna_CFG_MERCHANT_ACCOUNT_TTL,
			'settings_description' 	=> Cmabna_CFG_MERCHANT_ACCOUNT_DSCR,
			'settings_html_function' 	=> 'setting_TEXT_BOX(0,', 
			'sort_order' 			=> 1,
		);		
		$this->SettingsFields['CONF_PAYMENTMODULE_MABNA_TERMINAL'] = array(
			'settings_value' 		=> '', 
			'settings_title' 			=> CMABNA_CFG_TERMINAL_ACCOUNT_TTL,
			'settings_description' 	=> Cmabna_CFG_TERMINAL_ACCOUNT_DSCR,
			'settings_html_function' 	=> 'setting_TEXT_BOX(0,', 
			'sort_order' 			=> 1,
		);

		$this->SettingsFields['CONF_PAYMENTMODULE_MABNA_RIAL_CURRENCY'] = array(
			'settings_value' 		=> '0', 
			'settings_title' 			=> Cmabna_CFG_RIAL_CURRENCY_TTL,
			'settings_description' 	=> Cmabna_CFG_RIAL_CURRENCY_DSCR,
			'settings_html_function' 	=> 'setting_CURRENCY_SELECT(', 
			'sort_order' 			=> 1,
		);
	}
}
?>